<template>
<div>
  <v-form @submit.prevent="login" ref="form" lazy-validation>
    <v-text-field type="email" label="Email" v-model="email" color="primary" :rules="rules.email"/>
    <v-text-field
        :type="show_password ? 'text' : 'password'"
        label="Senha"
        v-model="password"
        :append-icon="show_password ? 'mdi-eye' : 'mdi-eye-off'"
        @click:append="show_password = !show_password"
        :rules="rules.password"
    />

    <slot/>

    <alert v-if="alert.showAlert" :show="alert.showAlert" :text="alert.msg" :type="alert.type" v-on:snackbar="alert.showAlert = false"/>
  </v-form>
</div>
</template>

<script>
export default {
  name: 'FormLogin',
  data () {
    return {
      email: null,
      password: null,
      show_password: false,

      alert: {
        showAlert: false,
        msg: '',
        type: ''
      },

      rules: {
        email: [
          v => !!v || 'Digite seu endereço de email',
          v => /.+@.+\..+/.test(v) || 'Endereço de mail inválido'
        ],
        password: [
          v => !!v || 'Preenchimento obrigatório',
          v => (v && v.length >= 6) || 'Mínimo de 6 carácteres'
        ]
      }
    }
  },
  methods: {
    async login () {
      if (this.$refs.form.validate()) {
        this.$emit('loading', true)
        await this.$auth.loginWith('local', {
          data: {
            email: this.email,
            password: this.password
          }
        }).catch((e) => {
          this.$emit('loading', false)
          const erros = e.response.data
          if (erros) {
            for (const erro in erros.errors) {
              this.alertError(erros.errors[erro][0], 'error')
            }
          }

          if (erros.msg) {
            this.alertError(erros.msg, 'error')
          }
        })
      }
    },
    alertError (erro = null, type = 'success') {
      if (this.alert.showAlert) {
        this.alert.showAlert = false
      }
      this.alert.showAlert = true
      this.alert.msg = erro
      this.alert.type = type
    }
  }
}
</script>

<style>

</style>
